//Grosu Maria Cristina
//Grupa 334CB
//LED Cube

#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>

 #define F_CPU 8000000UL

/* joc de lumini cub intreg */
void fullCube()
{
	int i = 0;
	while (i <= 5)
	{		
		PORTD = 0x0f;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(1000);
		
		PORTD = 0xf0;
		PORTA = 0x00;
		PORTC = 0x00;
		
		_delay_ms(1000);
		
		i++;
	}
}

/* high_low */
void high_low()
{
	int i = 0;
	while (i <= 4)
	{
		PORTD=0x10;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(5000);
	
		PORTD=0x20;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(5000);
	
		PORTD=0x80;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(5000);
	
		PORTD=0x40;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(5000);
		
		PORTD=0x80;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(5000);
		
		PORTD=0x20;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(5000);
		
		i++;
	}
}

/* snail like */
void snail()
{
	int i = 0;
	while (i <= 14)
	{
		PORTD=0xf0;
		PORTA=0x48;
		PORTC=0x21;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTA=0xc0;
		PORTC=0x03;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTC=0xc0;
		PORTA=0x30;
		
		_delay_ms(1000);

		PORTD=0xf0;
		PORTC=0x84;
		PORTA=0x21;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTC=0x88;
		PORTA=0x22;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTC=0x11;
		PORTA=0x44;
		
		_delay_ms(1000);
		
		i++;
	}

}

void energetic()
{
	int i = 0;
	while (i <= 2)
	{
		PORTD = 0x80;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(225);

		PORTD = 0x40;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(225);

		PORTD = 0x20;
		PORTA = 0xff;
		PORTC = 0xf;
		
		_delay_ms(225);

		PORTD = 0x10;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(225);
		
		i++;
	}
}

int main()
{
	//setez pinii corespunzatoare led-urilor ca output
	DDRA = 0xff;
	DDRC = 0xff;
	DDRD = 0xff;
	
	while (1)
	{
		fullCube(); 		
		high_low();
		energetic(); 
		snail();

	}
}
